Subject: Re: [PATCH][net-next] net/devlink: Move health recovery notification after abort check

From: Jakub Kicinski <[email-masked]>
Date: Wed, 25 Feb 2026 19:31:32 -0800

On Tue, 24 Feb 2026 21:10:03 -0500 lirongqing wrote:
> In devlink_health_report(), the DEVLINK_CMD_HEALTH_REPORTER_RECOVER
> notification is sent immediately after setting the error state, before
> checking if recovery should be aborted via devlink_health_recover_abort().
> 
> When devlink_health_recover_abort() returns true (e.g., due to rate
> limiting), the recovery process terminates early, but userspace has already
> received a notification implying that recovery is underway. This creates a
> misleading view of the reporter's activity.
> 
> Move the notification after the abort check, ensuring it is only sent when
> recovery will actually proceed. This aligns the notification with the
> actual recovery behavior.

Hm, we don't have solid documentation for this notification, but I
think it's supposed to be triggered on any change in the health state.
It's not just a notification that recovery has taken place.
devlink_health_reporter_state_update() for instance sends it whether
the update is healthy -> error or error -> healthy.
-- 
pw-bot: reject